# grabIT

A simple script to take a screenshot, upload it to atums.world, and copy the link to the clipboard.

## Requirements

### Wayland
- `grim`
- `slurp`
- `wl-copy`
- `curl`, `jq`

### X11
- `flameshot`
- `xclip`
- `curl`, `jq`

### Other
- `xdg-utils`
- tk
- Python 3

## Setup

Copy the `env.example` and change values, all are required but headers

```bash
cp .env.example .env
```

## Usage

Take a screenshot and upload:
```bash
./upload.sh
```

Upload an existing file:
```bash
./upload.sh path/to/image.png
```

Upload clipboard image:
```bash
./upload.sh -c
```

## Notes
- Detects Wayland/X11 automatically.
- Copies the upload link to the clipboard.
- Shows a preview of the uploaded image.

## License
[MIT](LICENSE)
